//+------------------------------------------------------------------+
//|                                                      4 color mtf |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property  indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  LimeGreen
#property  indicator_color2  DarkGreen
#property  indicator_color3  Red
#property  indicator_color4  Maroon
#property  indicator_color5  DimGray
#property indicator_width1   2
#property indicator_width2   2
#property indicator_width3   2
#property indicator_width4   2
#property indicator_width5   2
#property indicator_level1   0
#property indicator_levelcolor Gold
#property indicator_levelstyle STYLE_DOT

//
//
//
//
//

extern string   TimeFrame             = "Current time frame";
extern int      degree                = 150;                 // Degree of autocorrelation for MESA (Maximum Entropy Spectrum Analysis)
extern int      length                = 100;                 // Number of previous Bars to perform MESA calculation
extern double   max_period            = 75;                 // Upper bound for SATL cutoff period (1/frequency)
extern double   min_period            = 15;                  // Lower bound for FATL cutoff period
extern double   satl_min_period       = 60.0;                // Lower bound for SATL (upper bound for FATL is 80% of "*")
extern datetime initial_time          = D'2011.01.01 00:00'; // if backwardBars=0, get it from initial_time
extern int      filterPersistenceBars = 100;                 // The SATL and FATL cutoff periods are re-calculated every "*" bars
extern int      backwardBars          = 100;                 // The indicator is drawn backard "*" bars       ** Check if == 0 ** (MESA_Cutoff_frequencies problems??
extern bool     rectify               = true;                // by Default fatl/satle curves are rectified to be continuous between two different filter sets
                                                             // by putting to false non-rectified curves are plotted. In this case must be paid attention
                                                             // with strategies that look at crossovers   
extern string   ex                    = "chooser=0=ftlm or chooser=1=stlm";                                                                                                                      
extern int      chooser               = 0;                   //0 - FTLM; 1 - STLM

double macd[];
double green_buffer[];
double dkgreen_buffer[];
double red_buffer[];
double maroon_buffer[];

//
//
//
//
//

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,green_buffer);     SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(1,dkgreen_buffer);   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(2,red_buffer);       SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(3,maroon_buffer);    SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexBuffer(4,macd);
   
      
   
   indicatorFileName = WindowExpertName();
   calculateValue    = (TimeFrame=="CalculateValue"); if (calculateValue) return(0);
   returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   
   IndicatorShortName(stringToTimeFrame(timeFrame)+ " ftlm-stlm adaptive ");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
  {
   
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit=MathMin(Bars-counted_bars,Bars-1);
         if (returnBars)  { green_buffer[0] = limit+1; return(0); }
   
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
      for(i=limit; i>=0; i--)
      {
         macd[i]           = iCustom(Symbol(),NULL,"R-FTLM-STLM-Adaptive",degree,length,max_period,min_period,satl_min_period,initial_time,filterPersistenceBars,backwardBars,rectify,chooser,i);
         dkgreen_buffer[i] = 0;
         green_buffer[i]   = 0;
         red_buffer[i]     = 0;
         maroon_buffer[i]  = 0;
        
         if(macd[i] > 0) 
               if (macd[i]>macd[i+1])
                     green_buffer[i]   = macd[i];
               else  dkgreen_buffer[i] = macd[i];
         if(macd[i] < 0) 
               if (macd[i]<macd[i+1])
                     red_buffer[i]    = macd[i];
               else  maroon_buffer[i] = macd[i];
      }
      return(0);
   }
  
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
     int y = iBarShift(NULL,timeFrame,Time[i]);
  
      macd[i]           = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",degree,length,max_period,min_period,satl_min_period,initial_time,filterPersistenceBars,backwardBars,rectify,"",chooser,4,y);
      green_buffer[i]   = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",degree,length,max_period,min_period,satl_min_period,initial_time,filterPersistenceBars,backwardBars,rectify,"",chooser,0,y);
      dkgreen_buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",degree,length,max_period,min_period,satl_min_period,initial_time,filterPersistenceBars,backwardBars,rectify,"",chooser,1,y);
      red_buffer[i]     = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",degree,length,max_period,min_period,satl_min_period,initial_time,filterPersistenceBars,backwardBars,rectify,"",chooser,2,y);
      maroon_buffer[i]  = iCustom(NULL,timeFrame,indicatorFileName,"CalculateValue",degree,length,max_period,min_period,satl_min_period,initial_time,filterPersistenceBars,backwardBars,rectify,"",chooser,3,y); 
   }
   return(0);
}


int stringToTimeFrame(string tfs)
{
   for(int l = StringLen(tfs)-1; l >= 0; l--)
   {
      int char = StringGetChar(tfs,l);
          if((char > 96 && char < 123) || (char > 223 && char < 256))
               tfs = StringSetChar(tfs, l, char - 32);
          else 
              if(char > -33 && char < 0)
                  tfs = StringSetChar(tfs, l, char + 224);
   }

   //
   //
   //
   //
   //
   
   int tf=Period();
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
   return(MathMax(tf,Period()));
}

